<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_SALVAGE_RETURN';
if (!@$_GET['popup'])
    $path_to_root = "..";
else	
    $path_to_root = "../..";

include_once($path_to_root . "/includes/session.inc");
include_once($path_to_root . "/includes/ui.inc");
include_once($path_to_root . "/inventory/includes/ui/salvage_returns_ui.inc");
include_once($path_to_root . "/inventory/includes/db/job_material_issues_db.inc");
include_once($path_to_root . "/services/includes/db/job_orders_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_db.inc"); 
include_once($path_to_root . "/inventory/includes/db/items_units_db.inc"); 
include_once($path_to_root . "/admin/db/transactions_db.inc"); 
include_once($path_to_root . "/projects/includes/db/projects_db.inc"); 
include_once($path_to_root . "/includes/approval_functions.inc"); 

$js = '';
$js .= get_js_open_window(900, 500);
$js .= get_js_date_picker();

global $systypes_array;

if (isset($_GET['RejectedID'])) {
    page(_($help_context = $systypes_array[ST_SALVAGE_RETURN]), false, false, "", $js);
    
    $trans_no = $_GET['RejectedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('slrt_rj_messages');
    clear_session_variable('slrt_rj_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if ((isset($_GET['slrt_no']) && is_numeric($_GET['slrt_no'])) || (isset($_POST['slrt_no']) && is_numeric($_POST['slrt_no']))) {
    $slrt_no = $_POST['slrt_no'] = isset($_GET['slrt_no']) ? $_GET['slrt_no'] : $_POST['slrt_no'];
    
    $page_title = _($systypes_array[ST_SALVAGE_RETURN]); 
    
} elseif (isset($_GET['ModifySLRT_No']) || isset($_POST['ModifySLRT_No'])) {
    $_POST['ModifySLRT_No'] = isset($_GET['ModifySLRT_No']) ? $_GET['ModifySLRT_No'] : $_POST['ModifySLRT_No'];
    $slrt_no = $_POST['ModifySLRT_No'];
    
    $header = get_job_material_issue_header_record($slrt_no);
        if (is_array($header)) {
            if ($header['type'] != ST_SALVAGE_RETURN) {
                page(_($help_context = ''), false, false, "", $js);
                display_error(("Invalid transaction type."));
                display_footer_exit();
            } 
            
            $_POST['jo_id'] = $header['jo_id'];
            $trans_no = $header['trans_no'];
        } else {
            page(_($help_context = ''), false, false, "", $js);
            display_error(("Invalid transaction ID."));
            display_footer_exit();
        }
    
    $page_title = _('Modify '.$systypes_array[ST_SALVAGE_RETURN]." #$trans_no" );
    
} elseif ((isset($_GET['jo_id']) && is_numeric($_GET['jo_id'])) || (isset($_POST['jo_id']) && is_numeric($_POST['jo_id']))) {
    $_POST['jo_id'] = isset($_GET['jo_id']) ? $_GET['jo_id'] : $_POST['jo_id'];
    
    $page_title = _('New '.$systypes_array[ST_SALVAGE_RETURN]); 
    $slrt_no = 0;
    
} elseif (isset($_GET['type']) && (isset($_GET['ApprovedID']) || isset($_GET['BackedOrgID']))) {
    $page_title = _($systypes_array[$_GET['type']]);
} else {
    page(_($help_context = ''), false, false, "", $js);
    display_error(("Invalid transaction type."));
    display_footer_exit();
}

page(_($help_context = $page_title), false, false, "", $js);

simple_page_mode(true);

if (isset($_GET['ApprovedID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['ApprovedID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('slrt_messages');
    clear_session_variable('slrt_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_GET['BackedOrgID'])) {
    global $systypes_array;
    
    $trans_no = $_GET['BackedOrgID'];
    $trans_type = $_GET['type'];
    $msg = get_session_variable('slrt_bo_messages');
    clear_session_variable('slrt_bo_messages');

    $type_name = $systypes_array[$trans_type];

    display_notification($msg);
    display_note(get_trans_view_str($trans_type, $trans_no, _("&View this $type_name #$trans_no.")), 0, 1);
    display_footer_exit();
}

if (isset($_POST['REJECT_SLRT'])) {
    $msg = reject_salvage_return($slrt_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['BACK_TO_ORIGINATOR_SLRT'])) {
    $msg = back_to_originator_salvage_return($slrt_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Save_SLRT_Header'])) {
    $msg = save_salvage_return_header_only($slrt_no);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            $Mode = 'RESET';
        }
}

if (isset($_POST['Approve_SLRT'])) {
    $msg = save_salvage_return_header_only($slrt_no, true);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } 
}

if (isset($_POST['Add_SLRT']) || isset($_POST['Update_SLRT'])) {        
    $msg = save_salvage_return($slrt_no, $selected_id);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_salvage_return_details();
            $Mode = 'RESET';
        }
}

if ($Mode == 'Delete') {
    $msg = delete_salvage_return_line($slrt_no, $selected_id);
        if ($msg['success'] !== true) {
            display_error($msg['message']);
        } else {
            display_notification($msg['message']);
            clear_salvage_return_details();
            $Mode = 'RESET';
        }
}

if (isset($_POST['cancel'])) {
    clear_salvage_return_details();
    
    $Mode = 'RESET';
    $selected_id = -1;
}  

if ($Mode == 'RESET') {
    $selected_id = -1;
}

global $Ajax;

start_form();

    if (isset($_POST['jo_id']) && $_POST['jo_id'] > 0) {
        hidden('jo_id', $_POST['jo_id']);
    }    
        
    if (isset($slrt_no) && $slrt_no > 0) {
        hidden('slrt_no', $slrt_no);
    } elseif (isset($_POST['slrt_no']) && $_POST['slrt_no'] > 0) {
        hidden('slrt_no', $_POST['slrt_no']);
        $slrt_no = $_POST['slrt_no'];
    } elseif(isset($_POST['ModifySLRT_No'])) {
        hidden('ModifySLRT_No', $_POST['ModifySLRT_No']);
        $slrt_no = $_POST['ModifySLRT_No'];
    } 

    $Ajax->activate('nsit_header');
    $Ajax->activate('_page_body');
    $Ajax->activate('salvage_returns');
    div_start('salvage_returns');
    
        display_salvage_return_header($slrt_no);

        $header = get_job_material_issue_header($slrt_no); 
            if (is_array($header)) {
                submit_center_first('Save_SLRT_Header', _("Save Header"), '', 'default');    

                submit('Approve_SLRT', _("Release for Approval"), true, _("Release for Approval"), false, ICON_SUBMIT);
            
                submit_center_last('Refresh', 'Refresh', 'Refresh', false, ICON_SUBMIT);                br(2);
                
                start_table();
                    submit_center_first('REJECT_SLRT', _("Reject ".$systypes_array[ST_SALVAGE_RETURN]), '', true, ICON_DELETE);    
                    
                    submit('BACK_TO_ORIGINATOR_SLRT', 'Back To Originator', true, 'Back To Originator', false, ICON_SUBMIT);
                end_table(2);
            }

        display_salvage_return_details($slrt_no, $selected_id, $Mode);

    div_end();
    
end_form();
end_page(@$_GET['popup'], false, false);        

?>